Index: trunk/sources/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Classification_Script.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Classification_Script.cs	(revision 11544)
+++ trunk/sources/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Classification_Script.cs	(revision 11545)
@@ -41,5 +41,5 @@
         { "gamma", ValueGenerator.GenerateSteps(-4m, -1, 1).Select(x => Math.Pow(2,(double)x)) },
 //        { "eps", ValueGenerator.GenerateSteps(-8m, -1, 1).Select(x => Math.Pow(2, (double)x)) },
-//        { "nu" , ValueGenerator.GenerateSteps(0m, 1, 0.05m).Select(x => Math.Pow(2, (double)x)) },
+        { "nu" , ValueGenerator.GenerateSteps(-10m, 0, 1m).Select(x => Math.Pow(2, (double)x)) },
 //        { "degree", ValueGenerator.GenerateSteps(1m, 4, 1).Select(x => (double)x) }
   };
@@ -57,6 +57,6 @@
   };
 
-  private static SupportVectorClassificationSolution SvmGridSearch(IClassificationProblemData problemData, out svm_parameter bestParameters, out int nSv) {
-    bestParameters = SupportVectorMachineUtil.GridSearch(problemData, svmParameterRanges, numberOfFolds, shuffleFolds, maximumDegreeOfParallelism);
+  private static SupportVectorClassificationSolution SvmGridSearch(IClassificationProblemData problemData, out svm_parameter bestParameters, out int nSv, out double cvMse) {
+    bestParameters = SupportVectorMachineUtil.GridSearch(out cvMse, problemData, svmParameterRanges, numberOfFolds, shuffleFolds, maximumDegreeOfParallelism);
     double trainingError, testError;
     string svmType = svmTypes[bestParameters.svm_type];
@@ -81,6 +81,7 @@
 
     int nSv; // number of support vectors
+    double cvMse;
     svm_parameter bestParameters;
-    var bestSolution = SvmGridSearch(problemData, out bestParameters, out nSv);
+    var bestSolution = SvmGridSearch(problemData, out bestParameters, out nSv, out cvMse);
 
     vars["bestSolution"] = bestSolution;
@@ -103,2 +104,3 @@
   }
 }
+
Index: trunk/sources/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Regression_Script.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Regression_Script.cs	(revision 11544)
+++ trunk/sources/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Regression_Script.cs	(revision 11545)
@@ -38,8 +38,8 @@
         { "svm_type", new List<double> {svm_parameter.NU_SVR } },
         { "kernel_type", new List<double> { svm_parameter.RBF }},
-        { "C", ValueGenerator.GenerateSteps(-1m, 10, 1).Select(x => Math.Pow(2, (double)x)) },
+        { "C", ValueGenerator.GenerateSteps(-1m, 12, 1).Select(x => Math.Pow(2, (double)x)) },
         { "gamma", ValueGenerator.GenerateSteps(-4m, -1, 1).Select(x => Math.Pow(2, (double)x)) },
 //        { "eps", ValueGenerator.GenerateSteps(-8m, -1, 1).Select(x => Math.Pow(2, (double)x)) },
-//        { "nu" , ValueGenerator.GenerateSteps(0m, 1, 0.05m).Select(x => Math.Pow(2, (double)x)) },
+        { "nu" , ValueGenerator.GenerateSteps(-10m, 0, 1m).Select(x => Math.Pow(2, (double)x)) },
 //        { "degree", ValueGenerator.GenerateSteps(1m, 4, 1).Select(x => (double)x) }
   };
@@ -57,6 +57,6 @@
   };
 
-  private static SupportVectorRegressionSolution SvmGridSearch(IRegressionProblemData problemData, out svm_parameter bestParameters, out int nSv) {
-    bestParameters = SupportVectorMachineUtil.GridSearch(problemData, svmParameterRanges, numberOfFolds, shuffleFolds, maximumDegreeOfParallelism);
+  private static SupportVectorRegressionSolution SvmGridSearch(IRegressionProblemData problemData, out svm_parameter bestParameters, out int nSv, out double cvMse) {
+    bestParameters = SupportVectorMachineUtil.GridSearch(out cvMse, problemData, svmParameterRanges, numberOfFolds, shuffleFolds, maximumDegreeOfParallelism);
     double trainingError, testError;
     string svmType = svmTypes[bestParameters.svm_type];
@@ -81,6 +81,7 @@
 
     int nSv; // number of support vectors
+    double cvMse;
     svm_parameter bestParameters;
-    var bestSolution = SvmGridSearch(problemData, out bestParameters, out nSv);
+    var bestSolution = SvmGridSearch(problemData, out bestParameters, out nSv, out cvMse);
 
     vars["bestSolution"] = bestSolution;
@@ -104,2 +105,3 @@
   }
 }
+